﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using JonathanHaas.ActiveVB.WB3;
using System.IO;
using System.Text.RegularExpressions;

namespace Main {
    class Program {
        static void Main(string[] args) {
            var Types = new List<String>();
            var Nodes = new List<ICollection<PathNode>>();
            var TypeRegex = new Regex(@" -> ");
            var StationRegex = new Regex(@"^\[(.*)\] *(.*) *-> *\((.*)\|(.*)\)$");
            var TypeInput = new StreamReader(args[0]);
            try {
                String line;
                while ((line = TypeInput.ReadLine()) != null) {
                    var T = TypeRegex.Split(line);
                    Types.AddRange(T);
                    for (int i = 0; i < T.Length; i++) {
                        Nodes.Add(new List<PathNode>());
                    }
                }
            }
            finally {
                TypeInput.Close();
            }
            var StationInput = new StreamReader(args[1]);
            try {
                String line;
                while ((line = StationInput.ReadLine()) != null) {
                    var match = StationRegex.Match(line);
                    var type = match.Groups[1].Value;
                    var name = match.Groups[2].Value;
                    var x = match.Groups[3].Value;
                    var y = match.Groups[4].Value;
                    for (int i = 0; i < Types.Count; i++) {
                        if (Types[i] == type) {
                            Nodes[i].Add(new PathNode(Double.Parse(x), Double.Parse(y), name));
                        }
                    }
                }
            }
            finally {
                StationInput.Close();
            }
            var start = DateTime.Now;
            new PathFinder().FindBestPath(0, Nodes.Count - 1, Nodes);
            System.Console.WriteLine("Benötigte Zeit: " + (DateTime.Now - start).TotalMilliseconds.ToString()  );
            System.Console.ReadKey();
        }
    }
}
